package com.example.photosynthproj;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.json.JSONException;
import org.json.JSONObject;

import com.example.utils.JSONBuilder;

import android.location.Criteria;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.EditText;

public class AddTagActivity extends Activity implements LocationListener  {

	EditText add_tag_et;
	int id;
	JSONObject resultsJSON;
	String token;
	ResearchProject researchProject;
	LocationManager locationManager;
	double lat;
	double lng;
	String provider;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_add_tag);
		add_tag_et=(EditText)findViewById(R.id.add_tag_et);
		
		researchProject = ((MyApplication) this.getApplication()).getResearchProject();
		id=researchProject.getId();
		
		token=((MyApplication) this.getApplication()).getToken();
		locationManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
		
		// Creating an empty criteria object
        Criteria criteria = new Criteria();
        
        // Getting the name of the provider that meets the criteria
        provider = locationManager.getBestProvider(criteria, false);
		
        if(provider!=null && !provider.equals("")){
        	 // Get the location from the given provider
            Location location = locationManager.getLastKnownLocation(provider);
            locationManager.requestLocationUpdates(provider, 20000, 1, this);
            
            if(location!=null){
            	
                onLocationChanged(location);
        }else{
            	Log.d("Test Thread ", "Location can't be retrieved");
            	
            }
 
        }else{
        	Log.d("Test Thread ", "No Provider Found");
        }
		
		Intent i=getIntent();
		String result=(String) i.getExtras().get("results");
		JSONBuilder jsonBuilder=new JSONBuilder();
	    resultsJSON=jsonBuilder.buildJSONObject(result);
	    //submitResults.put("auth_token", token);
		
	    Log.d("Test Thread","get"+" "+result);
	    
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.activity_add_tag, menu);
		return true;
	}
	
	public void click_submit(View view)
	{
		 //submitResults.put("auth_token", token);
		String tag=add_tag_et.getText().toString();
		JSONObject submitResults = null;
		
	   
		 try {
			resultsJSON.put("tags", tag);
			//this is where to include GPS 
		    submitResults=new JSONObject();
			submitResults.put("auth_token", token);
			submitResults.put("latitude", lat);
			submitResults.put("longitude", lng);
		    submitResults.put("datum",resultsJSON);
		    Log.d("Test Thread", "submit results"+" "+submitResults.toString());
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		 Log.d("Test Thread", "in action tag"+" "+submitResults.toString());
		 NetworkPostResultsThread thread=new NetworkPostResultsThread(submitResults,id);
		 thread.start();
		 
		 try {
			thread.join();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		 	JSONObject jsonObject=thread.getResponseJSON();
		 	int id=0;
		 	try {
				id=(Integer) jsonObject.get("id");
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		 	Log.d("Test Thread","id"+" "+String.valueOf(id));
		   Intent intent=new Intent(this, DisplayResultsActivity.class);
		   intent.putExtra("id", id);
		   intent.putExtra("research Project", researchProject);
		   startActivity(intent);
		 
		 
		 
	}
	
	@Override
	public void onLocationChanged(Location location) {
		 lat = (double) (location.getLatitude());
		 lng = (double) (location.getLongitude());
		 Log.d("Test Thread","lat+long"+" "+lat+" "+lng);
		
	}

	@Override
	public void onProviderDisabled(String arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onProviderEnabled(String arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onStatusChanged(String arg0, int arg1, Bundle arg2) {
		// TODO Auto-generated method stub
		
	}
	
	
	class NetworkPostResultsThread extends Thread
	{
		//api/v1/projects/1/data.json
		String url="http://photosynq.venturit.org/api/v1/projects/1/data.json";
		String name;
		String password;
		
		JSONObject resultsJSONObject;
		JSONObject token;
		JSONObject responseJSON;
		int id;

		
		int TIMEOUT_MILLISEC = 10000;
		
		
		public NetworkPostResultsThread(JSONObject resultsJSONObject,int id)
		{
			this.resultsJSONObject=resultsJSONObject;
			Log.d("Test Thread", "results"+" "+resultsJSONObject.toString());
			this.id=id;
			
		}
		
		
		@Override
		public void run() {
			int TIMEOUT_MILLISEC = 10000;
			HttpParams httpParams = new BasicHttpParams();
	        HttpConnectionParams.setConnectionTimeout(httpParams, TIMEOUT_MILLISEC);
	        HttpConnectionParams.setSoTimeout(httpParams, TIMEOUT_MILLISEC);
	        HttpClient httpclient = new DefaultHttpClient();
	        String url="http://photosynq.venturit.org/api/v1/projects/"+id+"/data.json";
	        HttpPost request = new HttpPost(url);
	       
			
			StringEntity input=null;
	        
	        //pass the object into a string entity
	        try {
	                input = new StringEntity(resultsJSONObject.toString());
	        } catch (UnsupportedEncodingException e1) {
	                e1.printStackTrace();
	        }
	        
	        input.setContentType("application/json");
	        
	        //pass the entity into a HttpPost request
	        request.setEntity(input);
	        InputStream is = null;
	       
	        try{
	               
	                //execute a request and get a response
	                HttpResponse response = httpclient.execute(request);
	                HttpEntity entityResponse = response.getEntity();
	                //get the entity from the response
	               
	                is=entityResponse.getContent();
	                this.responseJSON=buildJSON(is);
	                String returnString=returnString(is);
	        }catch(Exception e){
	                Log.d("error", e.toString() );
	        }
	       
	        
	        super.run();
	}
		
		public JSONObject getResponseJSON()
		{
			return this.responseJSON;
		}

		
		private JSONObject buildJSON(InputStream is)
		{
			JSONBuilder jsonBuilder=new JSONBuilder();
			String jsonString=jsonBuilder.buildJSONString(is);
			JSONObject jsonObject=jsonBuilder.buildJSONObject(jsonString);
			return jsonObject;
			
		}
		private String returnString(InputStream is)
		{
		        StringBuilder sb = new StringBuilder();
		        try{
		        BufferedReader reader = new BufferedReader(new InputStreamReader(is));
		        String line = null;
		                while ((line = reader.readLine()) != null) {
		                                sb.append(line + "\n");
		                }
		                           is.close();
		                }catch(Exception e){
		                                System.out.println(e.toString());
		                }
		
		                return sb.toString();
		}
		
		
					
	}

	
	

}
