package com.example.photosynthproj;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.example.utils.JSONBuilder;

import android.os.Bundle;
import android.app.Activity;
import android.content.Intent;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;

public class ResearchProjActivity extends Activity {
	String token;
	int id;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_research_proj);
		token=((MyApplication) this.getApplication()).getToken();
		
		
		NetworkPostResultsThread thread=new NetworkPostResultsThread(token);
		thread.start();
		try {
			thread.join();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		JSONArray jsonArray=thread.getResponseJSON();
		
		ArrayList<ResearchProject> researchProjectList=new ArrayList<ResearchProject>();
		for(int i =0;i<jsonArray.length();i++){
			
			try {
				JSONObject jsonObject=jsonArray.getJSONObject(i);
				ResearchProject researchProject1=new ResearchProject();
				researchProject1.setNameOfPerson("Greg Austic");
				researchProject1.setId(jsonObject.getInt("id"));
				researchProject1.setProfilePictureUrl("http://www.phlmetropolis.com/Cats.jpg");
				researchProject1.setNameOfProj(jsonObject.getString("name"));
				researchProject1.setDescription(jsonObject.getString("description"));
			    researchProject1.setDataCaptureTime("5 secs");
				researchProject1.setAdditionalInformation("Additional Information for project 1 is like this..");
				researchProject1.setPhotoString("simple_leaf");
				researchProject1.setNumOfCollaborators(20);
				researchProjectList.add(researchProject1);
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} 
			
			
		}

		
		ResearchProjectAdapter ra=new ResearchProjectAdapter(this, researchProjectList);
		ListView lv=(ListView)findViewById(R.id.researchProjListView);
		lv.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView adapterView, View view, int position,
					long id) {
					ResearchProject researchProject=(ResearchProject) adapterView.getItemAtPosition(position);
					((MyApplication) getApplicationContext()).setResearchProject(researchProject);
					Intent intent=new Intent(getApplicationContext(), ResearchProjectItemActivity.class);
					intent.putExtra("research Project", researchProject);
					startActivity(intent);
				}
			});
		lv.setAdapter(ra);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.activity_research_proj, menu);
		return true;
	}
	
	class NetworkPostResultsThread extends Thread
	{

		String name;
		String password;
		String tokenString;
		
		JSONObject token;
		JSONArray responseJSONArray;
		String rAeturnString;

		
		int TIMEOUT_MILLISEC = 30000;
		
		
		public NetworkPostResultsThread(String token)
		{//
			this.tokenString=token;
			Log.d("Test Thread", token);
			
		}
		
		
		@Override
		public void run() {
			int TIMEOUT_MILLISEC = 30000;
			HttpParams httpParams = new BasicHttpParams();
	        HttpConnectionParams.setConnectionTimeout(httpParams, TIMEOUT_MILLISEC);
	        HttpConnectionParams.setSoTimeout(httpParams, TIMEOUT_MILLISEC);
	        HttpClient httpclient = new DefaultHttpClient();
	        String url="http://photosynq.venturit.org/api/v1/projects.json?auth_token="+tokenString;
	        HttpGet request = new HttpGet(url);
	    
	        InputStream is = null;
	       
	        try{
	                HttpResponse response = httpclient.execute(request);
	                HttpEntity entityResponse = response.getEntity();
	                is=entityResponse.getContent();
	                responseJSONArray=buildJSON(is);
	                Log.d("Test Thread", "return json"+" "+responseJSONArray.toString());
	                Log.d("Test Thread", "return json #"+" "+responseJSONArray.length());
	        }catch(Exception e){
	                Log.d("error", e.toString() );
	        }
	 
	        super.run();
	}
		
		public JSONArray getResponseJSON()
		{
			return this.responseJSONArray;
		}
		
		private JSONArray buildJSON(InputStream is)
		{
			JSONBuilder jsonBuilder=new JSONBuilder();
			String jsonString=jsonBuilder.buildJSONString(is);
			Log.d("Test Thread", "json string"+" "+jsonString);
			JSONArray jsonArray=buildJSONArray(jsonString);
			return jsonArray;
		}
		
		 public JSONArray buildJSONArray(String JSONString){
		    	JSONArray js = null;
		    	try {
					 js=new JSONArray(JSONString);
				} catch (JSONException e) {
					// TODO Auto-generated catch block
					Log.d("Exception",e.toString());
				}
		    	return js;
		    	
		    }
		private String returnString(InputStream is)
		{
		        StringBuilder sb = new StringBuilder();
		        try{
		        BufferedReader reader = new BufferedReader(new InputStreamReader(is));
		        String line = null;
		                while ((line = reader.readLine()) != null) {
		                                sb.append(line + "\n");
		                }
		                           is.close();
		                }catch(Exception e){
		                                System.out.println(e.toString());
		                }
		
		                return sb.toString();
		}
	}
}
